searchData={"items":[{"type":"module","doc":"A module for verifying captcha response strings.","title":"OmniCaptcha","ref":"OmniCaptcha.html"},{"type":"function","doc":"Verifies a response string.","title":"OmniCaptcha.verify/2","ref":"OmniCaptcha.html#verify/2"},{"type":"function","doc":"* `:adapter` - sets the adapter that is used to load related configuration for the provider (defaults to `OmniCaptcha.Adapter.Sandbox`)\n  * `:http_client` - sets the HTTP client used for the verification request (defaults to `OmniCaptcha.Http`)\n  * `:timeout` - the timeout for the request (defaults to 5000ms)\n  * `:secret`  - the secret key used by :omni_captcha (defaults to the secret\n    provided in application config)\n  * `:remoteip` - the IP address of the user (optional and not set by default)","title":"Options - OmniCaptcha.verify/2","ref":"OmniCaptcha.html#verify/2-options"},{"type":"function","doc":"iex> {:ok, api_response} = OmniCaptcha.verify(\"response_string\")","title":"Example - OmniCaptcha.verify/2","ref":"OmniCaptcha.html#verify/2-example"},{"type":"module","doc":"A struct representing the successful OmniCaptcha response from the Cloudflare OmniCaptcha API.","title":"OmniCaptcha.Response","ref":"OmniCaptcha.Response.html"},{"type":"type","doc":"","title":"OmniCaptcha.Response.t/0","ref":"OmniCaptcha.Response.html#t:t/0"},{"type":"module","doc":"Responsible for rendering boilerplate OmniCaptcha HTML code, supports noscript fallback.\n\n  In future this module may be separated out into a Phoenix specific library.","title":"OmniCaptcha.Template","ref":"OmniCaptcha.Template.html"},{"type":"function","doc":"Renders the captcha widget.","title":"OmniCaptcha.Template.captcha/1","ref":"OmniCaptcha.Template.html#captcha/1"},{"type":"function","doc":"* `:adapter` - sets the adapter that is used to load related configuration for the provider. (defaults to `OmniCaptcha.Adapter.Sandbox`)\n  * `:site_key` - sets the site key used by the provider captcha widget. (defaults to the site_key provided in the application config)","title":"Options - OmniCaptcha.Template.captcha/1","ref":"OmniCaptcha.Template.html#captcha/1-options"},{"type":"function","doc":"Renders the captcha script.","title":"OmniCaptcha.Template.script/1","ref":"OmniCaptcha.Template.html#script/1"},{"type":"function","doc":"* `:adapter` - sets the adapter that is used to load related configuration for the provider. (defaults to `OmniCaptcha.Adapter.Sandbox`)\n  * `:script_opts` - optional script options can be set for callbacks or other configuration (defaults to application configuration or \"\" if not provided)","title":"Options - OmniCaptcha.Template.script/1","ref":"OmniCaptcha.Template.html#script/1-options"},{"type":"module","doc":"Adapter for HCaptcha integration\nhttps://docs.hcaptcha.com/\n\nTest Keys: https://docs.hcaptcha.com/#integration-testing-test-keys\n\nPlease refer to `OmniCaptcha.Template` for details on use of this adapter.","title":"OmniCaptcha.Adapter.HCaptcha","ref":"OmniCaptcha.Adapter.HCaptcha.html"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.HCaptcha.captcha/1","ref":"OmniCaptcha.Adapter.HCaptcha.html#captcha/1"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.HCaptcha.script/1","ref":"OmniCaptcha.Adapter.HCaptcha.html#script/1"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.HCaptcha.verify_url/0","ref":"OmniCaptcha.Adapter.HCaptcha.html#verify_url/0"},{"type":"module","doc":"Adapter for Google reCAPTCHA v2 integration https://developers.google.com/recaptcha/docs/display\n\nTest Keys\n\nSite Key: 6LeIxAcTAAAAAJcZVRqyHh71UMIEGNQ_MXjiZKhI\n\nSecret Key: 6LeIxAcTAAAAAGG-vFI1TnRWxMZNFuojJ4WifJWe\n\nPlease refer to `OmniCaptcha.Template` for details on use of this adapter.","title":"OmniCaptcha.Adapter.ReCaptcha","ref":"OmniCaptcha.Adapter.ReCaptcha.html"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.ReCaptcha.captcha/1","ref":"OmniCaptcha.Adapter.ReCaptcha.html#captcha/1"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.ReCaptcha.script/1","ref":"OmniCaptcha.Adapter.ReCaptcha.html#script/1"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.ReCaptcha.verify_url/0","ref":"OmniCaptcha.Adapter.ReCaptcha.html#verify_url/0"},{"type":"module","doc":"Adapter for development or testing with **no** captcha\n\nPlease refer to `OmniCaptcha.Template` for details on use of this adapter.","title":"OmniCaptcha.Adapter.Sandbox","ref":"OmniCaptcha.Adapter.Sandbox.html"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.Sandbox.captcha/1","ref":"OmniCaptcha.Adapter.Sandbox.html#captcha/1"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.Sandbox.script/1","ref":"OmniCaptcha.Adapter.Sandbox.html#script/1"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.Sandbox.verify_url/0","ref":"OmniCaptcha.Adapter.Sandbox.html#verify_url/0"},{"type":"module","doc":"Adapter for Cloudflare Turnstile integration\nhttps://developers.cloudflare.com/turnstile/\n\nTest Keys: https://developers.cloudflare.com/turnstile/reference/testing/\n\nPlease refer to `OmniCaptcha.Template` for details on use of this adapter.","title":"OmniCaptcha.Adapter.Turnstile","ref":"OmniCaptcha.Adapter.Turnstile.html"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.Turnstile.captcha/1","ref":"OmniCaptcha.Adapter.Turnstile.html#captcha/1"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.Turnstile.script/1","ref":"OmniCaptcha.Adapter.Turnstile.html#script/1"},{"type":"function","doc":"","title":"OmniCaptcha.Adapter.Turnstile.verify_url/0","ref":"OmniCaptcha.Adapter.Turnstile.html#verify_url/0"},{"type":"module","doc":"Responsible for managing HTTP requests to the captcha APIs","title":"OmniCaptcha.Http","ref":"OmniCaptcha.Http.html"},{"type":"function","doc":"","title":"OmniCaptcha.Http.client/1","ref":"OmniCaptcha.Http.html#client/1"},{"type":"function","doc":"Sends an HTTP request to the specified adapters verify url.","title":"OmniCaptcha.Http.request_verification/2","ref":"OmniCaptcha.Http.html#request_verification/2"},{"type":"function","doc":"* `:adapter` - sets the adapter to use if using multiple captacha providers in the same project\n  * `:timeout` - the timeout for the request (defaults to 5000ms)","title":"Options - OmniCaptcha.Http.request_verification/2","ref":"OmniCaptcha.Http.html#request_verification/2-options"},{"type":"function","doc":"{:ok, %{\n    \"success\" => success,\n    \"challenge_ts\" => ts,\n    \"hostname\" => host,\n    \"error-codes\" => errors\n  }} = OmniCaptcha.Http.request_verification(%{\n    secret: \"secret\",\n    response: \"response\",\n    remoteip: \"remoteip\"\n  })","title":"Example - OmniCaptcha.Http.request_verification/2","ref":"OmniCaptcha.Http.html#request_verification/2-example"},{"type":"module","doc":"A mock HTTP client used for testing.","title":"OmniCaptcha.Http.MockClient","ref":"OmniCaptcha.Http.MockClient.html"},{"type":"function","doc":"","title":"OmniCaptcha.Http.MockClient.request_verification/2","ref":"OmniCaptcha.Http.MockClient.html#request_verification/2"},{"type":"extras","doc":"# OmniCaptcha\n\nThe package is fork of the [hcaptcha] package that has been modified to be adaptable.\n\n[hcaptcha]: https://github.com/sebastiangrebe/hcaptcha","title":"OmniCaptcha","ref":"readme.html"},{"type":"extras","doc":"The repo works for me but is not tested that all configuration options or callbacks given by captcha providers are processed correctly. Feel free to open PRs to resolve issues that you may experience.","title":"Important Notice - OmniCaptcha","ref":"readme.html#important-notice"},{"type":"extras","doc":"1. Add omni_captcha to your `mix.exs` dependencies\n\n```elixir\n  defp deps do\n    [\n      {:omni_captcha, \"~> 0.0.1\"},\n    ]\n  end\n```\n\n2. List `:omni_captcha` as an application dependency\n\n```elixir\n  def application do\n    [ extra_applications: [:omni_captcha] ]\n  end\n```\n\n3. Run `mix do deps.get, compile`","title":"Installation - OmniCaptcha","ref":"readme.html#installation"},{"type":"extras","doc":"Specify the adapter to have a default adapter to be used across the project.\n\nThe following adapters currently available in the project include:\n\n- `OmniCaptcha.Adapter.HCaptcha`\n- `OmniCaptcha.Adapter.ReCaptcha`\n- `OmniCaptcha.Adapter.Turnstile`\n- `OmniCaptcha.Adapter.Sandbox`\n\nBy default the public and private keys are loaded via the `OMNI_CAPTCHA_PUBLIC_KEY` and `OMNI_CAPTCHA_PRIVATE_KEY` environment variables.\n\n```elixir\n  config :omni_captcha,\n    adapter: OmniCaptcha.Adapter.Turnstile\n    site_key: System.fetch_env!(\"OMNI_CAPTCHA_SITE_KEY\"),\n    secret_key: System.fetch_env!(\"OMNI_CAPTCHA_SECRET_KEY\")\n```","title":"Config - OmniCaptcha","ref":"readme.html#config"},{"type":"extras","doc":"By default `omni_captcha` will use `Jason` to decode JSON responses, this can be changed as such:\n\n```elixir\n  config :omni_captcha, :json_library, Poison\n```","title":"JSON Decoding - OmniCaptcha","ref":"readme.html#json-decoding"},{"type":"extras","doc":"Render the omni_captcha script in the head block.\n\n```elixir\n \n   \n \n```\n\n| Option        | Action                                               | Default |\n| :------------ | :--------------------------------------------------- | :------ |\n| `adapter`     | Sets the default adapter to use for captcha provider | sandbox |\n| `script_opts` | Configurable script options for the selected script  | \"\"      |","title":"Load the Script - OmniCaptcha","ref":"readme.html#load-the-script"},{"type":"extras","doc":"Render the embed inside the form.\n\n```elixir\n<%= form_for ... %>\n   \n<% end %>\n```\n\n| Option     | Action                                               | Default                       |\n| :--------- | :--------------------------------------------------- | :---------------------------- |\n| `adapter`  | Sets the default adapter to use for captcha provider | sandbox                       |\n| `site_key` | Site key to render with the Captcha widget           | Site key from the config file |","title":"Render the Widget - OmniCaptcha","ref":"readme.html#render-the-widget"},{"type":"extras","doc":"OmniCaptcha provides the `verify/2` method. Below is an example using a Phoenix controller action:\n\nTurnstile\n\n```elixir\n  def create(conn, params) do\n    case OmniCaptcha.verify(params[\"cf-turnstile-response\"]) do\n      {:ok, response} -> do_something\n      {:error, errors} -> handle_error\n    end\n  end\n```\n\nreCAPTCHA\n\n```elixir\n  def create(conn, params) do\n    case OmniCaptcha.verify(params[\"g-recaptcha-response\"]) do\n      {:ok, response} -> do_something\n      {:error, errors} -> handle_error\n    end\n  end\n```\n\nhCaptcha\n\n```elixir\n  def create(conn, params) do\n    case OmniCaptcha.verify(params[\"h-captcha-response\"]) do\n      {:ok, response} -> do_something\n      {:error, errors} -> handle_error\n    end\n  end\n```\n\n`verify` method sends a `POST` request to the omni_captcha API and returns 2 possible values:\n\n`{:ok, %OmniCaptcha.Response{challenge_ts: timestamp, hostname: host}}` -> The captcha is valid, see the [documentation](https://developers.google.com/turnstile/docs/verify#api-response) for more details.\n\n`{:error, errors}` -> `errors` contains atomised versions of the errors returned by the API, See the error documentation for more details. Errors caused by timeouts in HTTPoison or Jason encoding are also returned as atoms. If the turnstile request succeeds but the challenge is failed, a `:challenge_failed` error is returned.\n\n(turnstile)[https://developers.cloudflare.com/turnstile/get-started/server-side-validation/#error-codes]\n(reCAPTCHA)[https://developers.google.com/recaptcha/docs/verify#error-code-reference]\n(hCaptcha)[https://docs.hcaptcha.com/configuration#error-codes]\n\n`verify` method also accepts a keyword list as the third parameter with the following options:\n\n| Option        | Action                                                | Default                          |\n| :------------ | :---------------------------------------------------- | :------------------------------- |\n| `adapter`     | Sets the default adapter to use for captcha provider  | sandbox                          |\n| `http_client` | Sets the default HTTP adapter in the package          | OmniCaptcha.Http                 |\n| `secret`      | Private key to send as a parameter of the API request | Private key from the config file |\n| `timeout`     | Time to wait before timeout                           | 5000 (ms)                        |\n| `remote_ip`   | Optional. The user's IP address, used by omni_captcha | no default                       |","title":"Verify API - OmniCaptcha","ref":"readme.html#verify-api"},{"type":"extras","doc":"This package allows for using more than one captcha at once if necessary.\n\nCustom modules are also supported if the validation API responds in a similar format.\n\n```elixir\nconn\n|> assign(adapter: OmniCaptcha.Adapter.HCaptcha)\n|> assign(site_key: \"asdf1234\")\n```\n\n```elixir\n \n   \n \n```\n\n```elixir\n<%= form_for ... %>\n   \n<% end %>\n```\n\n```elixir\nOmniCaptcha.verify(\n  params[\"captcha-response\"],\n  adapter: OmniCaptcha.Adapter.HCaptcha,\n  secret: \"4321fdsa\"\n)\n```","title":"Running multiple captchas - OmniCaptcha","ref":"readme.html#running-multiple-captchas"},{"type":"extras","doc":"To recieve only valid responses from the live Turnstile API use the following config.\n\n```elixir\nconfig :omni_captcha,\n  secret_key: \"1x0000000000000000000000000000000cAA\"\n```\n\nTo recieve only invalid responses from the live Turnstile API use the following config.\n\n```elixir\nconfig :omni_captcha,\n  secret_key: \"2x0000000000000000000000000000000AA\"\n```\n\nSetting up tests without network access can be done also. When configured as such a positive or negative result can be generated locally.\n\n```elixir\nconfig :omni_captcha,\n  http_client: OmniCaptcha.Http.MockClient,\n  secret_key: \"test_secret_key\"\n\n\n  {:ok, _details} = OmniCaptcha.verify(\"valid_response\")\n\n  {:error, _details} = OmniCaptcha.verify(\"invalid_response\")\n\n```","title":"Testing - OmniCaptcha","ref":"readme.html#testing"},{"type":"extras","doc":"[MIT License](http://www.opensource.org/licenses/MIT).","title":"License - OmniCaptcha","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}